unit Eprom;

interface

uses  PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Typ256: Boolean;
  Adresse, Anzahl: Integer;

const BA = $378;             { LPT1 }

implementation

{$R *.DFM}

procedure Setzen (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;        { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;        { D2=CS2=0 }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA+2,((Port_Nr AND 3) + 4) XOR 11); { Steuerkommando }
  OutPort (BA, CS);                         { D0=St=0 }
  OutPort (BA+2, Wert XOR 11);              { Datenwort }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA, 6 + 1);                      { CS1=1, CS2=1 }
end;

function Lesen (Port_Nr : Byte): Byte;
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;        { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;        { D2=CS2=0 }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA+2,(Port_Nr AND 3) XOR 11);    { Steuerkommando }
  OutPort (BA, CS);                         { D0=St=0 }
  OutPort (BA+2, 15 XOR 11);                { Bus hochohmig }
  Delayus (10);
  Lesen := InPort(BA+2) AND 15 XOR 11;      { Daten lesen }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA, 6 + 1);                      { CS1=1, CS2=1 }
end;

procedure AND_Port (Port_Nr,Wert: Byte); var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;        { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;        { D2=CS2=0 }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA+2,((Port_Nr AND 3) + 12) XOR 11); { Steuerkommando }
  OutPort (BA, CS);                         { D0=St=0 }
  OutPort (BA+2, Wert XOR 11);              { Datenwort }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA, 6 + 1);                      { CS1=1, CS2=1 }
end;

procedure OR_PORT (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;        { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;        { D2=CS2=0 }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA+2,((Port_Nr AND 3) + 8) XOR 11); { Steuerkommando }
  OutPort (BA, CS);                         { D0=St=0 }
  OutPort (BA+2, Wert XOR 11);              { Datenwort }
  OutPort (BA, CS + 1);                     { D0=St=1 }
  OutPort (BA, 6 + 1);                      { CS1=1, CS2=1 }
end;

procedure DatenSetzen (Wert: Byte);
begin
  Setzen (0, Wert mod 16);                 { P0: D0..D3 }
  Setzen (1, Wert div 16);                 { P1: D4..D7 }
end;

function DatenLesen: Byte;
begin
  DatenLesen := Lesen (0) + 16 * Lesen (1);  { zweimal }
  DatenLesen := Lesen (0) + 16 * Lesen (1);  { P0,P1 lesen }
end;

procedure AdresseSetzen (Adresse: Word); begin
  Setzen (2, Lo (Adresse) mod 16);         { P2: A0...A3 }
  Setzen (3, Lo (Adresse) div 16);         { P3: A4...A7 }
  Setzen (4, Hi (Adresse) mod 16);         { P4: A8...A11 }
  Setzen (5, Hi (Adresse) div 16);         { P5: A12...A13 }
  If Typ256 then begin
    if Adresse < 16384 then AND_Port (6,11)  { P62=A14=0 }
    else OR_Port (6,4);                      { P62=A14=1 }
  end;
end;

function Auslesen (Adresse: Word): Byte; begin
  Setzen (6,4);                            {/CE=0, /OE=0 }
  AdresseSetzen (Adresse);
  Auslesen := Datenlesen;
end;

procedure Brennen (Adresse: Word; Wert: Byte); begin
  AdresseSetzen (Adresse);
  DatenSetzen (Wert);
  If Typ256 then begin
    OR_Port (6,11);                        { /OE=1, Vpp an }
    AND_Port (6,14);                       { /CE=0 }
  end else Setzen (6,10);                  { Vpp, /OE=1, /PGM=0 }
  delay (1);                               { 1ms brennen }
  Setzen (6,7);                            { Upp aus, /CE=1, /PGM=1 }
end;

procedure BrennenUndPruefen (Adresse: Word; Wert: Byte);
var n, m: Integer;
begin
  n := 0;
  repeat
    Brennen (Adresse,Wert);
    n := n + 1;                                 { n * 1ms }
  until (Wert >= Auslesen (Adresse)) or (n=50);
  for m := 1 to 3*n do Brennen (Adresse,Wert);  { 3*n ms }
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom ('LPT1:');
  Typ256 := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
 VAR  f :file of byte;
      r,wert :Byte;
      Adresse, n, Code : Integer;
begin
   val (Edit1.Text, Adresse, Code);
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      for n:= 1 to filesize (f) do begin
        Read(f,wert);
        BrennenUndPruefen (Adresse+n-1,Wert);
      end;
      CloseFile(f);
      Edit3.Text := 'Brennen OK'
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
 VAR  f :file of byte;
      r,wert :Byte;
      Adresse, Anzahl,n, Code : Integer;
begin
   val (Edit1.Text, Adresse, Code);
   val (Edit2.Text, Anzahl, Code);
   SaveDialog1.FileName := '*.bin';
   SaveDiaLog1.Execute;
   if SaveDialog1.FileName > '' then begin
     AssignFile(f,SaveDialog1.Filename);
    {$I-} Rewrite(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      for n:= Adresse to (Adresse+Anzahl-1) do begin
        Wert := Auslesen (n);
        write (f,Wert);
      end;
      CloseFile(f);
      end;
      Edit3.Text := 'OK';
  end;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  Typ256 := false;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  Typ256 := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
 VAR  f :file of byte;
      r,wert :Byte;
      Adresse, Anzahl,n, Code : Integer;
      Fehler : Boolean;
begin
   Fehler := false;
   val (Edit1.Text, Adresse, Code);
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
       for n:= 1 to filesize (f) do begin
        Read(f,wert);
        If Wert <> Auslesen (Adresse+n-1) then Fehler := true;
      end;
      CloseFile(f);
    end;
      if Fehler then Edit3.Text := 'Fehler!'
        else Edit3.Text := 'EPROM OK';
   end;
end;

end.
