unit I2CLPT1;

interface
 uses  PORTINC, Windows;

const BA = $378;

Procedure I2C_Init;
Procedure Start;
Procedure Stop;
Procedure Acknowledge;
Procedure KeinAcknowledge;
Function Ausgeben (Wert : Byte): Boolean;
Function  Einlesen : Byte;


implementation
procedure I2C_Init;
begin
  OpenCOM (Pchar('LPT1:'));
  OutPort (BA+2,0);          { SCL=1, SDA=1 }
end;

procedure Start;
begin
  OutPort (BA+2,1);          { SDA=0 }
  OutPort (BA+2,3);          { SCL=0 }
end;

procedure Stop;
begin
  OutPort (BA+2,3);          { SCL=0, SDA=0 }
  OutPort (BA+2,1);          { SCL=1 }
  OutPort (BA+2,0);          { SDA=1 }
end;

procedure Acknowledge;
begin
  OutPort (BA+2,3);          { SCL=0, SDA=0 }
  OutPort (BA+2,1);          { SCL=1 }
  Delayus (10);              { Warteschleife }
  OutPort (BA+2,3);          { SCL=0 }
end;

procedure KeinAcknowledge;
begin
  OutPort (BA+2,2);          { SCL=0, SDA=1 }
  OutPort (BA+2,0);          { SCL=1 }
  Delayus (10);              { Warteschleife }
  OutPort (BA+2,2);          { SCL=0 }
end;

Function Ausgeben (Wert : Byte): Boolean;
var Bitwert, Portwert, n : Byte;
begin
  Ausgeben := true;
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then Portwert := 2
     else Portwert := 3;
    OutPort (BA+2,Portwert);      { SDA setzen }
    OutPort (BA+2,Portwert-2);    { SCL=1 }
    Delayus (10);                 { Warteschleife }
    OutPort (BA+2,Portwert);      { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  OutPort (BA+2,2);                { SDA=1, SCL=0 }
  OutPort (BA+2,0);                { SCL=1, SDA lesen }
  Delayus (10);                    { Warteschleife }
  if (InPort(BA+2) AND 1) = 0 then
     Ausgeben := False;
  OutPort (BA+2,2);                { SCL=0 }
end;

function Einlesen : Byte;
var Bitwert, Wert, n : Byte;
begin
  OutPort (BA+2,2);                 { SDA=1, SCL=0 }
  Bitwert := 128;
  Wert := 0;
  for n:= 1 to 8 do begin
    OutPort (BA+2,0);               { SCL=1, SDA lesen }
    Delayus (10);                   { Warteschleife }
    If (InPort (BA+2) AND 1) = 0 then
         Wert := Wert + Bitwert;
    OutPort (BA+2,2);               { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  Einlesen := Wert;
end;

end.
