unit Ohrtest;

interface

uses PortInc,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    Ja: TButton;
    Neu: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure NeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JaClick(Sender: TObject);
  end;

var
  Form1: TForm1;
  Diagramm: Boolean;

implementation

{$R *.DFM}

procedure DiagrammInit;
var n: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
  Pen.Color:=ClBlack;
  Brush.Color:=ClWhite;
  Rectangle(40,10,336,185);
  Pen.Color:=ClLtGray;
  for n:= 0 to 8 do begin
      MoveTo(41,15+n*20);
      Lineto (335,15+n*20);
  end;
  Brush.Color:=ClLtGray;
  for n:= 0 to 8 do begin
    TextOut(0,10+n*20,'-'+FloatToStr(n*10)+' dB');
  end;
  for n:= 0 to 2 do begin
      MoveTo(45+120*n,183); Lineto (45+120*n,10);
      MoveTo(45+120*n+36,183); Lineto (45+120*n+36,10);
      MoveTo(45+120*n+57,183); Lineto (45+120*n+57,10);
      MoveTo(45+120*n+72,183); Lineto (45+120*n+72,10);
      MoveTo(45+120*n+83,183); Lineto (45+120*n+83,10);
  end;
  TextOut(40+00,187,'100');
  TextOut(40+83,187,'500');
  TextOut(35+120,187,'1000');
  TextOut(35+203,187,'5000');
  TextOut(30+240,187,'10000 Hz');
  end;
  Diagramm := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
CONST RATE=44100;
VAR Size,t,val:Integer;
    Amp, Freq, Gauss: Real;
    p:pchar;
begin
     if not Diagramm then DiagrammInit;
     Size:=RATE div 4;
     GetMem(p,Size*2);
     Amp := 32000 / exp(ScrollBar2.Position/20*ln(10));
     Edit2.Text := '-'+FloatToStr(ScrollBar2.Position)+' dB' ;
     Freq := round (100* exp(ScrollBar1.Position/12*ln(2)));
     Edit1.Text := FloatToStr(Freq)+ ' Hz';
     For t:= 0 to Size -1 do
     BEGIN
          Gauss := exp(-1*(sqr((t-Size/2)/Size*4)));
          val:=Round(0+Amp*Gauss*sin(2*pi*freq*t/RATE));
          p[t*2]:=chr(LO(val));
          p[t*2+1]:=chr(HI(val));
     end;
     SoundSetRate(Rate);
     SoundSetBytes(2);
     SoundOut(p,Size);
     FreeMem(p);

end;

procedure TForm1.NeuClick(Sender: TObject);
begin
DiagrammInit;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Diagramm := false;
end;

procedure TForm1.JaClick(Sender: TObject);
var X, Y: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
    Pen.Color:=ClBlack;
    Brush.Color:=ClRed;
    X:=3*ScrollBar1.Position+45-2;
    Y:=2*ScrollBar2.Position+15-2;
    Ellipse (X,Y,X+5,Y+5);
  end;
end;

end.

