.title "RS232/19200 KB"
  .vers "st6215"
  .input "6215_reg.asm"

  .romsize 2
  .pp_on

dummy   .def 084H


  .section 1

  .org 80h
reset   ldi ddra,00000010B ;A0 Eingang RXD, kein pull-up
        ldi ora, 00000010B ;A1 Ausgang TXD P/P
        ldi dra, 00000001B ;A2/3 Eingnge

        ldi ddrb,00000000B  ;B erstmal Eingnge
        ldi orb, 00000000B
        ldi drb, 00000000B

        ldi ddrc,00000000B  ;C erstmal Eingnge
        ldi orc, 00000000B
        ldi drc, 00000000B
        reti

  .org 600h ;hochgesetzt, damit auch die OTP-Version
            ;mit tieferer Adresse noch einmal programmiert
            ;werden kann

mainlp  ldi wdr,0FEH       ;Watchdog-Reset
        jrr  0,dra,mainlp  ;Warten auf Startbit
        call Empf2         ;RS232-Empfnger nach Startb. 11
        jrs  7,a,lesen   ;>= 128: Register Lesen  +5
schreib addi a,128       ;Kommando 1: Register Schreiben +4
        ld   x,a         ;Registeradresse         +4
        call Empf        ;Daten                   +4 = 28
        ld  (x),a        ;ins Register schreiben  11+4
        jp mainlp        ;                        +4 = 22
lesen   ld  x,a          ;Registeradresse
        ld  a,(x)        ;auslesen
        call Send        ;zurcksenden
        jp  mainlp


Empf    jrr  0,dra,Empf  ;Rs232 RXD=A0, 19,2k / 4MHz 5..10
        ldi  dummy,0     ;4
Empf2   ldi  a,0         ;4  hier Einsprung nach Startb.
        ldi  dummy,0     ;4
        nop              ;2 : 21 bis 27 nach Startbit
data0   jrs  0,dra,wait0 ;5
        addi a,1         ;4
        jrnc  data1      ;2
wait0   addi a,0
        nop
data1   jrs  0,dummy,data1  ;5  16/bit
        jrs  0,dra,wait1    ;5
        addi a,2            ;4
        jrnc  data2         ;2
wait1   addi a,0
        nop
data2   jrs  0,dummy,data2  ;5  16/bit
        jrs  0,dra,wait2    ;5
        addi a,4            ;4
        jrnc  data3         ;2
wait2   addi a,0
        nop
data3   jrs  0,dummy,data3  ;5  16/bit
        jrs  0,dra,wait3    ;5
        addi a,8            ;4
        jrnc  data4         ;2
wait3   addi a,0
        nop
data4   jrs  0,dummy,data4  ;5  16/bit
        jrs  0,dra,wait4    ;5
        addi a,16           ;4
        jrnc  data5         ;2
wait4   addi a,0
        nop
data5   jrs  0,dummy,data5  ;5  16/bit
        jrs  0,dra,wait5    ;5
        addi a,32           ;4
        jrnc  data6         ;2
wait5   addi a,0
        nop
data6   jrs  0,dummy,data6  ;5  16/bit
        jrs  0,dra,wait6    ;5
        addi a,64           ;4
        jrnc  data7         ;2
wait6   addi a,0
        nop
data7   jrs  0,dummy,data7  ;5  16/bit
        jrs  0,dra,wait7    ;5
        addi a,128          ;4
wait7   ret                 ;2  11, Stopbit frei


;RS232-Senden mit 19200 Baud/4MHz, TXD=A1
Send    ldi  dummy,0        ;4
        ldi  dra,00000011B  ;Startbit
        nop                 ;2
        jrr  0,dummy,bit1   ;5
bit1    jrs  0,a,s10        ;5
        ldi  dra,00000011B  ;4  16/bit
        jrnc s0             ;2
s10     ldi  dra,00000001B
        nop
s0      jrs  0,dummy,s0     ;5
        jrs  1,a,s11        ;5
        ldi  dra,00000011B  ;4  16/bit
        jrnc  s1            ;2
s11     ldi  dra,00000001B
        nop
s1      jrs  0,dummy,s1     ;5
        jrs  2,a,s21        ;5
        ldi  dra,00000011B  ;4
        jrnc  s2            ;2
s21     ldi  dra,00000001B
        nop
s2      jrs  0,dummy,s2     ;5
        jrs  3,a,s31        ;5
        ldi  dra,00000011B  ;4
        jrnc  s3            ;2
s31     ldi  dra,00000001B
        nop
s3      jrs  0,dummy,s3     ;5
        jrs  4,a,s41        ;5
        ldi  dra,00000011B  ;4
        jrnc  s4            ;2
s41     ldi  dra,00000001B
        nop
s4      jrs  0,dummy,s4     ;5
        jrs  5,a,s51        ;5
        ldi  dra,00000011B  ;4
        jrnc  s5            ;2
s51     ldi  dra,00000001B
        nop
s5      jrs  0,dummy,s5     ;5
        jrs  6,a,s61        ;5
        ldi  dra,00000011B  ;4
        jrnc  s6            ;2
s61     ldi  dra,00000001B
        nop
s6      jrs  0,dummy,s6     ;5
        jrs  7,a,s71        ;5
        ldi  dra,00000011B  ;4
        jrnc  s7            ;2
s71     ldi  dra,00000001B
        nop
s7      nop                 ;2
        nop                 ;2
        nop                 ;2
        nop                 ;2
        nop                 ;2  16/bit
        ldi  dra,00000001B  ;Stopbit
        ret

  .section 32
  .org 00h
adc      nop
         reti
timer    nop
         reti
int2     nop
         reti
int1     nop
         reti
  .org 0ch
nmi      nop
         reti
res      jp reset

